## toulbar2 1.1.0+dfsg

=== CMakeLists.txt ===
##########################################
# cmake file for toulbar2 building, testing and packaging
# version 0.9 -# David allouche 17/10/10
##########################################

cmake_minimum_required(VERSION 2.6)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
set (My_Source src)	# source location 
set (doc_destination "share/doc")   #path of doc installation 
set (My_misc_source misc/src/)
list(APPEND CMAKE_MODULE_PATH "${My_cmake_script}/Modules")

set (MAINTAINER "David Allouche <david.allouche@inrae.fr>") #used in packaging 
set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging

##########################################
# PROJECT NAME
##########################################

project("toulbar2")

MESSAGE(STATUS "##########################################")
MESSAGE(STATUS "project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
MESSAGE(STATUS "source:${CMAKE_CURRENT_SOURCE_DIR} ")
MESSAGE(STATUS "MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "##########################################")

include(CMakeDependentOption)

##########################################
# cmake option definition
##########################################
#	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 
OPTION(MENDELSOFT "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
OPTION(ILOG  "ilog solver binding [default: off]" OFF)
OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
OPTION(Boost "boost graph binding [default: on]" ON) 
OPTION(MPI "MPI [default: off]" OFF)
OPTION(LONG_COSTS  "use long long to encode costs [default:on]" ON)
OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)
OPTION(QUAD_PROBABILITY  "use quadmath to encode probabilities [default:off]" OFF)
OPTION(BUILD_API_DOC "build and install HTML documentation with doxygen [default:off]" OFF)
OPTION(BUILD_API_DOC_LATEX "build and install LaTeX PDF documentation with doxygen [default:off]" OFF)
OPTION(STATIC "static compilation flag [default: off]" OFF)
OPTION(verbose "verbose mode [default:on]" ON)
OPTION(COVER_TEST "cover test [default:on]" ON)
OPTION(BENCH "benchmarcking [default:off]" OFF)
OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc) [default on]" ON)

MARK_AS_ADVANCED(FORCE BUILD_API_DOC_LATEX)
MARK_AS_ADVANCED(FORCE CPLEX ILOG XML verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS)
MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS GMP_LIBRARY MPI_LIBRARY MPI_EXTRA_LIBRARY)
MARK_AS_ADVANCED(FORCE BENCH)

##########################################
#Default profile for compilation
##########################################
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the build type, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )

IF(CPLEX)
  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
  SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
  SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPLEXFLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS " ${CPLEXLIB}")
  SET (all_depends  ${all_depends} "ilocplex") 
  SET (all_depends  ${all_depends} "cplex") 
  SET (all_depends  ${all_depends} "concert") 
  SET (all_depends  ${all_depends} "m") 
  SET (all_depends  ${all_depends} "pthread") 
  SET (all_depends  ${all_depends} "boost") 
  SET(STATIC OFF)
ENDIF(CPLEX)

if(verbose) 
  set (CMAKE_VERBOSE_MAKEFILE ON)
endif(verbose)

##########################################
# Compile Options on recent 64 bytes Macs. 
# thanks to alex rudnick 
##########################################
IF(APPLE)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
  SET(STATIC OFF)
  SET(WITH_MEM_JEMALLOC OFF)
ENDIF(APPLE)

##########################################
# default OPTION for toulbar2 test  phase
##########################################
SET(FOPT "test-opt.cmake" CACHE STRING "filename containing local options used for validation")
SET(Default_test_option CACHE STRING "Define toulbar2 option used in command line for testing: cf toulbar2 command line")
SET(Default_test_timeout 300 CACHE STRING "default test timeout")
SET(Default_validation_dir "validation" CACHE STRING "default location of validation files")
SET(Default_cover_dir "cover" CACHE STRING "default location of cover test files")
SET(Default_regexp "end." CACHE STRING "default regex searched in test output")
SET(Default_BenchDir "benchmarks" CACHE STRING "default location of benchmark files")
SET(Default_BenchFormat "wcsp" CACHE STRING "default format extension for benchmark files search") 
SET(Default_bench_timeout 30 CACHE STRING "default timeout used for benchmarking ")
SET(Default_bench_option "TOULBAR2_OPTION" CACHE STRING " option used in command line for benchmarking.")
SET(Default_bench_regexp "test ok" CACHE STRING "default regex searched in bench output")
MARK_AS_ADVANCED(FORCE Default_test_option Default_test_timeout Default_validation_dir Default_cover_dir Default_regexp Default_BenchDir Default_BenchFormat Default_bench_timeout Default_bench_option Default_bench_regexp)

##########################################
# static building
##########################################
IF(STATIC)
  MESSAGE(STATUS "STATIC COMPILATION ON (warning: jemalloc, xml, and MPI options not compliant with static link)")
  SET(WITH_MEM_JEMALLOC OFF)
  SET(XML OFF)
  SET(MPI OFF)
  set(Boost_USE_STATIC_LIBS ON)  # only find static libs
  SET(BUILD_SHARED_LIBS OFF)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++") 
ELSE()
  SET(BUILD_SHARED_LIBS ON) #shared library building
ENDIF(STATIC)

##########################################
# OPTION DEPENDANCES 
##########################################

IF(MENDELSOFT)
  MESSAGE(STATUS "##########################################")
  MESSAGE(STATUS " MENDELSOFT COMPILATION AND PACKAGING ONLY")
  MESSAGE(STATUS "##########################################")
  
  SET(TOULBAR2 OFF)
  SET(ILOG OFF)
  SET(LIBTB2 OFF)
  SET(XML OFF)
  SET(CPLEX OFF)
  SET(Boost OFF)
  SET(MPI OFF)
  
  #basename for packaging and versioning
  set (Toulbar2_NAME "mendelsoft")
  #description used in the package building
  SET (Toulbar2_PACKAGE_DESCRIPTION 
    "MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree data with genotyping data at a single locus. The output of the software is a list of individuals for which the removal of their genotyping data restores consistency. This list is of minimum size when the program ends.") 
  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} is an open source software which detect Mendelian errors in complex pedigrees using weighted constraint satisfaction techniques")
ELSE(MENDELSOFT)
  MESSAGE(STATUS "###############################################")
  MESSAGE(STATUS " TOULBAR2 Solver Compilation and Packaging Only")
  MESSAGE(STATUS "###############################################")

  SET(TOULBAR2 ON)
  #basename for packaging and versionning
  SET(Toulbar2_NAME "toulbar2")
  #description used in the package building
  SET(Toulbar2_PACKAGE_DESCRIPTION "${Toulbar2_NAME} is an open source C++ exact solver and library for discrete graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSPs/Weighted MaxSAT or Quadratic Pseudo-Boolean Optimization.")
  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} exact solver for discrete graphical models.")
ENDIF(MENDELSOFT)

IF(ILOG)
  set(LIBTB2 ON)
ENDIF(ILOG)

SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})

##########################################
# Windows options
##########################################
IF(WIN32)
  # option used for cross compilation 
  set (EXE ".exe")
  set(COST INT_COST)
  set(LIBTB2 OFF)
  set(XML OFF)
  set(CPLEX OFF)
  set(Boost OFF)
  set(MPI OFF)
  set(ILOG OFF)

  # mingW32 env setup
  include(${My_cmake_script}/mingw32-config.cmake) 
  
  MESSAGE(STATUS "WIN32 ON")
ELSE(WIN32)
  SET(COST LONGLONG_COST)
ENDIF(WIN32)

##########################################
# Find optional libs 
##########################################

include(${My_cmake_script}/source_files.cmake)

IF(PYTB2)
  SET(WITH_MEM_JEMALLOC OFF)
  SET(MPI OFF)
  SET(LIBTB2 ON)
  FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
  EXECUTE_PROCESS(
    COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
    OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
  MESSAGE(STATUS "Python3 suffix: ${Python3_SUFFIX}")
  EXECUTE_PROCESS(
    COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
    OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
  MESSAGE(STATUS "Pybind11 includes: ${Pybind11_INCLUDES}")
ENDIF(PYTB2)

IF(WITH_MEM_JEMALLOC)
  find_package(JeMalloc)
  IF(JEMALLOC_FOUND)
    link_directories(${JEMALLOC_LIBPATH})
    SET (all_depends  ${all_depends} "jemalloc") 
  ENDIF(JEMALLOC_FOUND)
ENDIF(WITH_MEM_JEMALLOC)

MESSAGE(STATUS "Search for GMP library")
INCLUDE(FindPkgConfig)
INCLUDE(${My_cmake_script}/FindGmp.cmake)
SET(all_depends  ${all_depends} "gmp") 
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 

INCLUDE(FindPkgConfig)
INCLUDE(FindGit)

IF(Boost) 
  INCLUDE(${My_cmake_script}/Boost_option.cmake)
  LINK_DIRECTORIES(${Boost_LIBRARY_DIR})
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
ENDIF(Boost)

IF(MPI) 
#  SET(CMAKE_C_COMPILER mpicc)
#  SET(CMAKE_CXX_COMPILER mpicxx)
#  SET(CMAKE_CXX_COMPILER /usr/mpi/gcc/openmpi-1.10.3rc4/bin/mpicxx)
#  SET(CMAKE_SYSTEM_PREFIX_PATH /usr/mpi/gcc/openmpi-1.10.3rc4)
  FIND_PACKAGE(MPI REQUIRED)
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
  SET(mpiflag OPENMPI)
ENDIF(MPI)

INCLUDE(${My_cmake_script}/xmlcsp.cmake)


##########################################
# Build executables
##########################################
# the list of source files used to compile is set in source_file.cmake
# new files need to be added to this list

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )

IF(TOULBAR2)
  ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
  ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
  ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
  ADD_DEPENDENCIES(toulbar2${EXE} gen_version)
  IF(MPI)
    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends} ${MPI_LIBRARIES})
    IF(MPI_COMPILE_FLAGS)
      set_target_properties(toulbar2${EXE} PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS}")
    ENDIF(MPI_COMPILE_FLAGS)
    IF(MPI_LINK_FLAGS)
      set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
    ENDIF(MPI_LINK_FLAGS)
  ELSE(MPI)

=== contrib/simpleini/Makefile ===

CC = g++

CFLAGS = -std=c++11 -g -Wall -I../../src -DBOOST -DLINUX -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY

OFLAGS = -O3 -DNDEBUG

toulbar2test: toulbar2test.cpp ../../lib/Linux/libtb2.so
	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< -L../.. -L../../lib/Linux -rdynamic ../../lib/Linux/libtb2.so -lgmp -lboost_graph -lboost_iostreams -lz -llzma -Wl,-rpath,../..:../../lib/Linux

clean:
	-rm -f *.o toulbar2test

all: toulbar2test

=== misc/script/Makefile ===
SRCSFULL = $(wildcard tb2*.cpp applis/*.cpp core/*.cpp globals/*.cpp incop/*.cpp search/*.cpp utils/*.cpp vns/*.cpp ToulbarVersion.cpp)

# Comment the following line if BOOST Graph library uninstalled
BOOST = -DBOOST

# Same thing for XML
#XML = XMLFLAG
#XMLI = -I/usr/include/libxml2 -DXMLFLAG
# -DXMLFLAG -DMAXCSP

ifeq ($(BOOST),-DBOOST)
SRCS = $(SRCSFULL)
else
SRCS = $(SRCSFULL:utils/tb2boostgraph.cpp=)
endif

ifeq ($(XML),XMLFLAG)
OBJS = $(SRCS:.cpp=.o) -lxml2 -lboost_graph -lboost_iostreams -lgmp -lz -llzma
# -lxml2 -lz -llzma -lm -lpthread
else
OBJS = $(SRCS:.cpp=.o) -lboost_graph -lboost_iostreams -lgmp -lz -llzma
endif

LIBSRCS = $(SRCS:tb2main.cpp=)
LIBOBJS = $(LIBSRCS:.cpp=.o)

CC = g++

# Library compatible with Ilog Solver:
# In order to link ToulBar2 with Ilog Solver, uncomment the following two lines starting with ILOGFLAGS and ILOGLIBS, and uncomment #define INT_COST (also adding comment to #define LONGLONG_COST) in tb2types.hpp
# Then recompile libtb2.so (make clean;make libtb2.so) and finaly compile iloglue (make iloglue)
# Usage: iloglue 16wqueens.wcsp [verbosity level]
# Ilog Solver 6.0
#ILOGFLAGS = -DILOGLUE -DIL_STD -I/usr/local/Ilog/solver60/include -I/usr/local/Ilog/concert20/include
#ILOGLIBS = -L/usr/local/Ilog/solver60/lib/i86_linux2_glibc2.3_gcc3.2/static_pic -L/usr/local/Ilog/concert20/lib/i86_linux2_glibc2.3_gcc3.2/static_pic -lsolverfloat -lsolver -lconcert
# Ilog Solver 6.5
# (warning: compile libtb2.so and iloglue with -O optimization and not -O3)
#ILOGFLAGS = -DILOGLUE -DIL_STD -I/usr/local/ILOG/solver65/include -I/usr/local/ILOG/concert25/include
#ILOGLIBS = -L/usr/local/ILOG/solver65/lib/x86-64_rhel4.0_3.4/static_pic -L/usr/local/ILOG/concert25/lib/x86-64_rhel4.0_3.4/static_pic -lsolverfloat -lsolver -lconcert

## PLPS cost functions needs CPLEX installed (update the following path depending on your configuration and uncomment the following three lines) *** Warning! Beta untested version for PLPS ***
##CPLEX_LOCATION = /opt/ibm/ILOG/CPLEX_Studio126
##CPLEXFLAGS = -DILOGCPLEX -DIL_STD -fPIC -fexceptions -fno-strict-aliasing -pthread -I$(CPLEX_LOCATION)/cplex/include/ilcplex -I$(CPLEX_LOCATION)/cplex/include -I$(CPLEX_LOCATION)/concert/include
##CPLEXLIB =  -L$(CPLEX_LOCATION)/cplex/lib/x86-64_linux/static_pic -L$(CPLEX_LOCATION)/concert/lib/x86-64_linux/static_pic -lilocplex -lcplex -lconcert -pthread -rdynamic 

CFLAGS = -std=c++11 -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLINUX -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
# -DLINUX # compile on linux computers
# -DLONGLONG_COST # uses type long long for encoding costs, to be replaced by -DINT_COST if memory is an issue (but costs are limited to 119304647)
# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities instead of type double if using -DDOUBLE_PROB
# -DWCSPFORMATONLY # assumes positive domains starting at value 0 (as in the wcsp format file) *** Incompatible with Numberjack ***
# -DNUMBERJACK # 
# -DOPENMPI # enables variable neighborhood search
# -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3 # catches numerical integer overflows
# -Wconversion # catch type conversion from larger to smaller type (e.g., Cost to int)

OFLAGS = -O3 -DNDEBUG
# -O3 -DNDEBUG

PFLAGS =
# -pg -g3

BUILD = $(CC) -shared

%.o : %.cpp
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

%.o : %.cpp %.hpp
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

%.o : %.cpp %.h
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

toulbar2: $(OBJS)
	$(CC) $(OBJS) -o $@ $(PFLAGS) -static -static-libgcc

libtb2.so: LIBFLAGS = -fPIC
libtb2.so: $(LIBOBJS)
	$(BUILD) $(LIBFLAGS) $(LIBOBJS) -o $@

toulbar2test: toulbar2test.cpp libtb2.so
	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< ./libtb2.so -lboost_graph -lboost_iostreams -lgmp -lz -llzma

iloglue: iloglue.cpp libtb2.so
	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< $(ILOGLIBS) -L. -ltb2 -lboost_graph -lboost_iostreams -lgmp -lz -llzma

clean:
	-rm -f *.o applis/*.o core/*.o globals/*.o incop/*.o search/*.o utils/*.o vns/*.o toulbar2 libtb2.so iloglue toulbar2test

all: toulbar2

=== debian/changelog ===
toulbar2 (1.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Adding new dependencies to control, and new options to compilation rules
  * Removing pre-push hook, useless for debian
  * Supposedly improved watch file
  * Recovering doc
  * Avoiding version generation
  * New upstream version 1.1.0+dfsg
  * Old patches removed, git-hooks excluded
  * New upstream version 1.1.0+dfsg

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Fri, 30 Oct 2020 10:14:29 +0000

## toulbar2 1.1.1%2Bdfsg

=== misc/script/Makefile ===
--- 
+++ 
@@ -43,8 +43,7 @@
 ##CPLEXFLAGS = -DILOGCPLEX -DIL_STD -fPIC -fexceptions -fno-strict-aliasing -pthread -I$(CPLEX_LOCATION)/cplex/include/ilcplex -I$(CPLEX_LOCATION)/cplex/include -I$(CPLEX_LOCATION)/concert/include
 ##CPLEXLIB =  -L$(CPLEX_LOCATION)/cplex/lib/x86-64_linux/static_pic -L$(CPLEX_LOCATION)/concert/lib/x86-64_linux/static_pic -lilocplex -lcplex -lconcert -pthread -rdynamic 
 
-CFLAGS = -std=c++11 -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLINUX -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
-# -DLINUX # compile on linux computers
+CFLAGS = -std=c++11 -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
 # -DLONGLONG_COST # uses type long long for encoding costs, to be replaced by -DINT_COST if memory is an issue (but costs are limited to 119304647)
 # -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities instead of type double if using -DDOUBLE_PROB
 # -DWCSPFORMATONLY # assumes positive domains starting at value 0 (as in the wcsp format file) *** Incompatible with Numberjack ***

## toulbar2 1.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,8 @@
 
 set (MAINTAINER "David Allouche <david.allouche@inrae.fr>") #used in packaging 
 set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging
+# default name for packaging
+SET(Toulbar2_NAME "toulbar2")
 
 ##########################################
 # PROJECT NAME
@@ -21,8 +23,8 @@
 project("toulbar2")
 
 MESSAGE(STATUS "##########################################")
-MESSAGE(STATUS "project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
-MESSAGE(STATUS "source:${CMAKE_CURRENT_SOURCE_DIR} ")
+MESSAGE(STATUS "project: ${PROJECT_NAME} toolkit compilation cmake file version 0.99")
+MESSAGE(STATUS "source: ${CMAKE_CURRENT_SOURCE_DIR} ")
 MESSAGE(STATUS "MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
 MESSAGE(STATUS "##########################################")
 
@@ -32,7 +34,6 @@
 # cmake option definition
 ##########################################
 #	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
-OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 
 OPTION(MENDELSOFT "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
 OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
 OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
@@ -60,6 +61,10 @@
 ##########################################
 #Default profile for compilation
 ##########################################
+IF(APPLE) # Find homebrew libraries first
+  set(CMAKE_PREFIX_PATH /usr/local)
+ENDIF(APPLE)
+
 IF(NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the build type, options are: None Debug Release RelWithDebInfo MinSizeRel."
@@ -68,6 +73,7 @@
 
 SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
 SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
+#SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto" )
 
 IF(CPLEX)
   SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
@@ -94,7 +100,7 @@
 ##########################################
 IF(APPLE)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
+  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64 -undefined dynamic_lookup" )
   SET(STATIC OFF)
   SET(WITH_MEM_JEMALLOC OFF)
 ENDIF(APPLE)
@@ -126,9 +132,10 @@
   set(Boost_USE_STATIC_LIBS ON)  # only find static libs
   SET(BUILD_SHARED_LIBS OFF)
   set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
-  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++") 
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --enable-static -static-libgcc -static-libstdc++")   # -flto 
 ELSE()
   SET(BUILD_SHARED_LIBS ON) #shared library building
+  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall")   # -flto
 ENDIF(STATIC)
 
 ##########################################
@@ -149,7 +156,7 @@
   SET(MPI OFF)
   
   #basename for packaging and versioning
-  set (Toulbar2_NAME "mendelsoft")
+  set(Toulbar2_NAME "mendelsoft")
   #description used in the package building
   SET (Toulbar2_PACKAGE_DESCRIPTION 
     "MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree data with genotyping data at a single locus. The output of the software is a list of individuals for which the removal of their genotyping data restores consistency. This list is of minimum size when the program ends.") 
@@ -160,11 +167,9 @@
   MESSAGE(STATUS "###############################################")
 
   SET(TOULBAR2 ON)
-  #basename for packaging and versionning
-  SET(Toulbar2_NAME "toulbar2")
   #description used in the package building
   SET(Toulbar2_PACKAGE_DESCRIPTION "${Toulbar2_NAME} is an open source C++ exact solver and library for discrete graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSPs/Weighted MaxSAT or Quadratic Pseudo-Boolean Optimization.")
-  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} exact solver for discrete graphical models.")
+  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} is an exact solver for discrete graphical models.")
 ENDIF(MENDELSOFT)
 
 IF(ILOG)
@@ -173,28 +178,6 @@
 
 SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
 SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})
-
-##########################################
-# Windows options
-##########################################
-IF(WIN32)
-  # option used for cross compilation 
-  set (EXE ".exe")
-  set(COST INT_COST)
-  set(LIBTB2 OFF)
-  set(XML OFF)
-  set(CPLEX OFF)
-  set(Boost OFF)
-  set(MPI OFF)
-  set(ILOG OFF)
-
-  # mingW32 env setup
-  include(${My_cmake_script}/mingw32-config.cmake) 
-  
-  MESSAGE(STATUS "WIN32 ON")
-ELSE(WIN32)
-  SET(COST LONGLONG_COST)
-ENDIF(WIN32)
 
 ##########################################
 # Find optional libs 
@@ -207,6 +190,7 @@
   SET(MPI OFF)
   SET(LIBTB2 ON)
   FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
+### Old cmake, python and pybind11
   EXECUTE_PROCESS(
     COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
     OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -215,6 +199,9 @@
     COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
     OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
   MESSAGE(STATUS "Pybind11 includes: ${Pybind11_INCLUDES}")
+### New cmake and python and pybind11
+#  FIND_PACKAGE(pybind11 CONFIG)
+###
 ENDIF(PYTB2)
 
 IF(WITH_MEM_JEMALLOC)
@@ -228,7 +215,7 @@
 MESSAGE(STATUS "Search for GMP library")
 INCLUDE(FindPkgConfig)
 INCLUDE(${My_cmake_script}/FindGmp.cmake)
-SET(all_depends  ${all_depends} "gmp") 
+SET(all_depends  ${all_depends} ${GMP_LIBRARY}) 
 INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 
 
 INCLUDE(FindPkgConfig)
@@ -264,6 +251,9 @@
 IF(TOULBAR2)
   ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
   ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
+  IF(STATIC)
+    TARGET_LINK_LIBRARIES(toulbar2${EXE} PUBLIC "-static")
+  ENDIF(STATIC)
   ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
   ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
   SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
@@ -277,3 +267,6 @@
       set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
     ENDIF(MPI_LINK_FLAGS)
   ELSE(MPI)
+    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends})
+  ENDIF(MPI)
+

=== contrib/simpleini/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 CC = g++
 
-CFLAGS = -std=c++11 -g -Wall -I../../src -DBOOST -DLINUX -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
+CFLAGS = -std=c++11 -g -Wall -I../../src -DBOOST -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
 
 OFLAGS = -O3 -DNDEBUG

=== debian/changelog ===
toulbar2 (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Tue, 19 Jan 2021 14:06:11 +0000

=== debian/control ===
Source: toulbar2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               bc,
               doxygen,
               doxygen-latex,
               libgmp-dev,
               graphviz,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libjemalloc-dev,
               zlib1g-dev,
	       liblzma-dev,
               libxml2-dev,
               pkg-config
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/toulbar2
Vcs-Git: https://salsa.debian.org/science-team/toulbar2.git
Homepage: http://www.inra.fr/mia/T/toulbar2

Package: toulbar2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: toulbar2-doc
Description: Exact combinatorial optimization for Graphical Models
 Toulbar2 is  an exact discrete optimization tool for Graphical Models
 such as Cost Function Networks, Markov Random Fields, Weighted Constraint
 Satisfaction Problems and Bayesian Nets.

Package: toulbar2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Exact combinatorial optimization for Graphical Models - documentation
 Toulbar2 is  an exact discrete optimization tool for Graphical Models
 such as Cost Function Networks, Markov Random Fields, Weighted Constraint
 Satisfaction Problems and Bayesian Nets.
 .
 This package contains the API reference and user documentation, descriptions
 of the various file formats that toulbar2 can read as well as examples.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
                -DXML=ON \
		-DMPI=OFF \
		-DBUILD_API_DOC:STRING=ON \
		-DBUILD_API_DOC_LATEX:STRING=ON

## toulbar2 1.2.1%2Bdfsg

=== debian/changelog ===
toulbar2 (1.2.1+dfsg-0.1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:07:12 +0200

toulbar2 (1.2.1+dfsg-0.1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:56:50 +0200

toulbar2 (1.2.1+dfsg-0.1) unstable; urgency=medium

  [ Thomas Schiex ]
  * New upstream version 1.2.1.
  * Added sphinx generated doc.
  * Includes bz2 library for proper decompression.
  * Removed useless misc directory from dfsg archive (avoids lintian error).  

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Set upstream metadata fields: Repository.

 -- Thomas Schiex <thomas.schiex@toulouse.inra.fr>  Wed, 03 Jan 2024 03:13:53 +0530

## toulbar2 1.2.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,12 @@
 # version 0.9 -# David allouche 17/10/10
 ##########################################
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.9)
+IF(APPLE)
+    cmake_minimum_required(VERSION 3.13)
+ENDIF(APPLE)
+cmake_policy(SET CMP0054 NEW)
+
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
 set (My_Source src)	# source location 
@@ -15,13 +20,12 @@
 set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging
 # default name for packaging
 SET(Toulbar2_NAME "toulbar2")
-
+SET(CMAKE_MACOSX_RPATH 1)
 ##########################################
 # PROJECT NAME
 ##########################################
 
 project("toulbar2")
-
 MESSAGE(STATUS "##########################################")
 MESSAGE(STATUS "project: ${PROJECT_NAME} toolkit compilation cmake file version 0.99")
 MESSAGE(STATUS "source: ${CMAKE_CURRENT_SOURCE_DIR} ")
@@ -29,7 +33,6 @@
 MESSAGE(STATUS "##########################################")
 
 include(CMakeDependentOption)
-
 ##########################################
 # cmake option definition
 ##########################################
@@ -38,15 +41,21 @@
 OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
 OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
 OPTION(ILOG  "ilog solver binding [default: off]" OFF)
-OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
+OPTION(XML "add a reader for the XCSP2/3 xml input format [default: off]" OFF)
+OPTION(XCSP3 "select XCSP3 format instead of XCSP2 [default: on]" ON)
 OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
 OPTION(Boost "boost graph binding [default: on]" ON) 
 OPTION(MPI "MPI [default: off]" OFF)
 OPTION(LONG_COSTS  "use long long to encode costs [default:on]" ON)
+OPTION(SHORT_COSTS  "use short int to encode costs [default:off]" OFF)
+OPTION(BINARYWCSP  "do not store binary costs (only binary WCSP with no variable elimination during search) [default:off]" OFF)
+OPTION(TERNARYWCSP  "do not store ternary costs (only ternary WCSP can be expressed) [default:off]" OFF)
+OPTION(SHORT_VALUES  "use short int to encode domain values instead of int [default:off]" OFF)
 OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)
 OPTION(QUAD_PROBABILITY  "use quadmath to encode probabilities [default:off]" OFF)
 OPTION(BUILD_API_DOC "build and install HTML documentation with doxygen [default:off]" OFF)
 OPTION(BUILD_API_DOC_LATEX "build and install LaTeX PDF documentation with doxygen [default:off]" OFF)
+OPTION(BUILD_SPHINX_DOC "build Sphinx documentation[default:off]" OFF)
 OPTION(STATIC "static compilation flag [default: off]" OFF)
 OPTION(verbose "verbose mode [default:on]" ON)
 OPTION(COVER_TEST "cover test [default:on]" ON)
@@ -54,7 +63,7 @@
 OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc) [default on]" ON)
 
 MARK_AS_ADVANCED(FORCE BUILD_API_DOC_LATEX)
-MARK_AS_ADVANCED(FORCE CPLEX ILOG XML verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS)
+MARK_AS_ADVANCED(FORCE CPLEX ILOG XML XCSP3 verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS SHORT_COSTS SHORT_VALUES NO_STORE_BINARY_COSTS NO_STORE_TERNARY_COSTS BINARYWCSP TERNARYWCSP)
 MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS GMP_LIBRARY MPI_LIBRARY MPI_EXTRA_LIBRARY)
 MARK_AS_ADVANCED(FORCE BENCH)
 
@@ -62,8 +71,19 @@
 #Default profile for compilation
 ##########################################
 IF(APPLE) # Find homebrew libraries first
+  message(STATUS "Apple/MacOS system detected. Selecting homebrew libraries first.")
   set(CMAKE_PREFIX_PATH /usr/local)
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
+  SET(STATIC OFF)
+  SET(WITH_MEM_JEMALLOC OFF)
 ENDIF(APPLE)
+
+IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/conan_paths.cmake)
+   message("Conan setup detected.")
+   INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/conan_paths.cmake)
+ELSE()
+   message("Conan file not found in ${CMAKE_CURRENT_SOURCE_DIR} - assuming conan free build.")
+ENDIF()
 
 IF(NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Release CACHE STRING
@@ -71,12 +91,13 @@
     FORCE)
 ENDIF(NOT CMAKE_BUILD_TYPE)
 
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
-SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++17" )
+# -fsanitize=address -fsanitize=undefined -Wconversion -Wsign-conversion
+SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize-undefined-trap-on-error -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
 #SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto" )
 
 IF(CPLEX)
-  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
+  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1210")
   SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
   SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPLEXFLAGS}")
@@ -86,24 +107,13 @@
   SET (all_depends  ${all_depends} "concert") 
   SET (all_depends  ${all_depends} "m") 
   SET (all_depends  ${all_depends} "pthread") 
-  SET (all_depends  ${all_depends} "boost") 
+  SET (all_depends  ${all_depends} "dl") 
   SET(STATIC OFF)
 ENDIF(CPLEX)
 
 if(verbose) 
   set (CMAKE_VERBOSE_MAKEFILE ON)
 endif(verbose)
-
-##########################################
-# Compile Options on recent 64 bytes Macs. 
-# thanks to alex rudnick 
-##########################################
-IF(APPLE)
-  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64 -undefined dynamic_lookup" )
-  SET(STATIC OFF)
-  SET(WITH_MEM_JEMALLOC OFF)
-ENDIF(APPLE)
 
 ##########################################
 # default OPTION for toulbar2 test  phase
@@ -131,11 +141,16 @@
   SET(MPI OFF)
   set(Boost_USE_STATIC_LIBS ON)  # only find static libs
   SET(BUILD_SHARED_LIBS OFF)
+  set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
   set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --enable-static -static-libgcc -static-libstdc++")   # -flto 
-ELSE()
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --disable-shared --enable-static -static-libgcc -static-libstdc++")   # -flto 
+  SET (all_depends  ${all_depends} "z") 
+  SET (all_depends  ${all_depends} "m") 
+  SET (all_depends  ${all_depends} "pthread") 
+  SET (all_depends  ${all_depends} "dl") # it should be present at the end of library ordering (checks manually no dynamic flags occur in the final link command)
+ELSE(STATIC)
   SET(BUILD_SHARED_LIBS ON) #shared library building
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall")   # -flto
+  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wall")   # -flto
 ENDIF(STATIC)
 
 ##########################################
@@ -188,13 +203,29 @@
 IF(PYTB2)
   SET(WITH_MEM_JEMALLOC OFF)
   SET(MPI OFF)
+  SET(XCSP3 OFF)
   SET(LIBTB2 ON)
+  SET(Python3_FIND_STRATEGY LOCATION)
+  SET(Python3_FIND_FRAMEWORK NEVER)
   FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
-### Old cmake, python and pybind11
-  EXECUTE_PROCESS(
-    COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
-    OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+  if(NOT Python3_Interpreter_FOUND)
+    MESSAGE(STATUS "Python3_Interpreter NOT FOUND")
+    SET(Python3_EXECUTABLE /usr/bin/python3)
+  else()
+    MESSAGE(STATUS "Python3_Interpreter FOUND")
+  endif()
+  MESSAGE(STATUS "Python3_EXECUTABLE: ${Python3_EXECUTABLE}")
+
+  if(EXISTS "${Python3_EXECUTABLE}-config")
+    SET(Python3_config "${Python3_EXECUTABLE}-config")
+    EXECUTE_PROCESS(COMMAND ${Python3_config} --extension-suffix OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+  else()
+    EXECUTE_PROCESS(COMMAND ${Python3_EXECUTABLE} -c "import sysconfig;print(sysconfig.get_config_var('EXT_SUFFIX'))" OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+  endif()
+
   MESSAGE(STATUS "Python3 suffix: ${Python3_SUFFIX}")
+
   EXECUTE_PROCESS(
     COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
     OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -213,60 +244,4 @@
 ENDIF(WITH_MEM_JEMALLOC)
 
 MESSAGE(STATUS "Search for GMP library")
-INCLUDE(FindPkgConfig)
-INCLUDE(${My_cmake_script}/FindGmp.cmake)
-SET(all_depends  ${all_depends} ${GMP_LIBRARY}) 
-INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 
-
-INCLUDE(FindPkgConfig)
-INCLUDE(FindGit)
-
-IF(Boost) 
-  INCLUDE(${My_cmake_script}/Boost_option.cmake)
-  LINK_DIRECTORIES(${Boost_LIBRARY_DIR})
-  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
-ENDIF(Boost)
-
-IF(MPI) 
-#  SET(CMAKE_C_COMPILER mpicc)
-#  SET(CMAKE_CXX_COMPILER mpicxx)
-#  SET(CMAKE_CXX_COMPILER /usr/mpi/gcc/openmpi-1.10.3rc4/bin/mpicxx)
-#  SET(CMAKE_SYSTEM_PREFIX_PATH /usr/mpi/gcc/openmpi-1.10.3rc4)
-  FIND_PACKAGE(MPI REQUIRED)
-  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
-  SET(mpiflag OPENMPI)
-ENDIF(MPI)
-
-INCLUDE(${My_cmake_script}/xmlcsp.cmake)
-
-
-##########################################
-# Build executables
-##########################################
-# the list of source files used to compile is set in source_file.cmake
-# new files need to be added to this list
-
-INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )
-
-IF(TOULBAR2)
-  ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
-  ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
-  IF(STATIC)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} PUBLIC "-static")
-  ENDIF(STATIC)
-  ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
-  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
-  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
-  ADD_DEPENDENCIES(toulbar2${EXE} gen_version)
-  IF(MPI)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends} ${MPI_LIBRARIES})
-    IF(MPI_COMPILE_FLAGS)
-      set_target_properties(toulbar2${EXE} PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS}")
-    ENDIF(MPI_COMPILE_FLAGS)
-    IF(MPI_LINK_FLAGS)
-      set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
-    ENDIF(MPI_LINK_FLAGS)
-  ELSE(MPI)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends})
-  ENDIF(MPI)
-
+find_package(PkgConfig)

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = source
BUILDDIR      = _build
FILESDIR      = source/_files

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	@echo "  pdfdocs     to delete $(FILESDIR) folder, generate pdf and save them into $(FILESDIR)"

.PHONY: help Makefile

# Get and adapt toulbar2/README.md :
# - delete lines 'master:...' and 'cpd:...' that are not ok for LaTeX
# - change some titles
readme:
	cat ../README.md > $(FILESDIR)/README.md
	sed -i '/^master:/d' $(FILESDIR)/README.md
	sed -i '/^cpd:/d' $(FILESDIR)/README.md
	sed -i '1,10 s/# toulbar2//' $(FILESDIR)/README.md
	sed -i '1,10 s/## Exact optimization/# Exact optimization/' $(FILESDIR)/README.md
	sed -i 's/<!-- \(.*\) -->/\1/g' $(FILESDIR)/README.md

# the two first lines (with svg's) are removed (build status and deployment)
readme_latex:
	make readme
	sed -i '/Build Status/d' $(FILESDIR)/README.md
	sed -i '/PyPi version/d' $(FILESDIR)/README.md

readme_html:
	rm -f $(FILESDIR)/README.md
	make readme

# build pdf files, get and adapt toulbar2/README.md
# and install them into FILESDIR
# Note : has to be done before html pages
files:
	rm -f $(FILESDIR)/*.*
	make readme_latex
	make latexpdf
	cp $(BUILDDIR)/latex/*.pdf $(FILESDIR)/.

# builds pdf, html files; pdf into html/pdf
docs:
	make clean
	make files
	make readme_html
	make html
	make files
	mkdir $(BUILDDIR)/html/pdf
	cp $(FILESDIR)/*.pdf $(BUILDDIR)/html/pdf/.

# epub not ok => not done :
# builds epub file; epub into html/epub
#   make epub
#   mkdir $(BUILDDIR)/html/epub
#   cp $(BUILDDIR)/epub/toulbar2.epub $(BUILDDIR)/html/epub/.

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx
sphinx_rtd_theme
breathe
myst-parser
ghp-import

=== debian/control ===
--- 
+++ 
@@ -3,21 +3,27 @@
 Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper (>= 13~),
                cmake,
                bc,
                doxygen,
                doxygen-latex,
+               python3-sphinx,
+               python3-myst-parser,
+               python3-sphinx-rtd-theme,
+               python3-breathe,
+               latexmk,
+               tex-gyre,
                libgmp-dev,
                graphviz,
                libboost-graph-dev,
                libboost-iostreams-dev,
                libjemalloc-dev,
                zlib1g-dev,
+               libbz2-dev,
 	       liblzma-dev,
-               libxml2-dev,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/toulbar2
 Vcs-Git: https://salsa.debian.org/science-team/toulbar2.git
 Homepage: http://www.inra.fr/mia/T/toulbar2
@@ -36,6 +42,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Exact combinatorial optimization for Graphical Models - documentation
  Toulbar2 is  an exact discrete optimization tool for Graphical Models
  such as Cost Function Networks, Markov Random Fields, Weighted Constraint

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with=sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
                -DXML=OFF \
		-DMPI=OFF \
		-DBUILD_API_DOC:STRING=ON \
		-DBUILD_API_DOC_LATEX:STRING=ON \
                -DBUILD_SPHINX_DOC:STRING=ON

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]\?//g,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%toulbar2-$1.tar.gz%" \
     https://github.com/toulbar2/toulbar2/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
